const PartytownSnippet = "!function(n,t){var r=n.partytown||{},e=r.forward||[],p=t.createElement(\"script\");function u(t){return function(){(n._ptf=n._ptf||[]).push(t,arguments)}}e.map((t=>{n[t[0]]=1===t[1]?function(n,t){return(t=[]).push=u(n),t}(t):u(t)})),p.async=p.defer=!0,p.src=(r.lib||\"/~partytown/\")+(r.debug?\"debug/\":\"\")+\"partytown.js\",t.head.appendChild(p)}(window,document);";

const debug = !!globalThis.partytownDebug;
const EMPTY_ARRAY = [];
if (debug) {
    Object.freeze(EMPTY_ARRAY);
}
/**
 * The `type` attribute for Partytown scripts, which does two things:
 *
 * 1. Prevents the `<script>` from executing on the main thread.
 * 2. Is used as a selector so the Partytown library can find all scripts to execute in a web worker.
 *
 * @public
 */
const SCRIPT_TYPE = `text/partytown`;

/**
 * @public
 */
const partytownSnippet = (config) => {
    const forward = config.forward || [];
    delete config.forward;
    return [
        `!(function(w,p,f,c){`,
        config && Object.keys(config).length > 0
            ? `c=w[p]=Object.assign(w[p]||{},${JSON.stringify(config)});`
            : `c=w[p]=w[p]||{};`,
        `c[f]=(c[f]||[])`,
        forward.length > 0 ? `.concat(${JSON.stringify(forward)})` : ``,
        `})(window,'partytown','forward');`,
        PartytownSnippet,
    ].join('');
};
/**
 * Gracefully adds a forward property to the global Partytown config. This
 * first ensures the `window.partytown.foward` exists, then adds the forward
 * property.
 *
 * @public
 */
const appendForwardProperty = (propertyName, propertyType) => `!(function(w,p,f,c){c=w[p]=w[p]||{};(c[f]=c[f]||[]).push(${JSON.stringify(propertyType ? [propertyName, propertyType] : [propertyName])})})(window,'partytown','forward');`;

export { SCRIPT_TYPE, appendForwardProperty, partytownSnippet };
